select
    an.cdanimal
    , an.dtnascimento
    , an.numero
    , ia.data as data_tentativa
    , (case ia.cdtiporeproducao when 1 then 'IA' when 2 then 'Cob' when 3 then 'TE' else null end) as tipo_tentativa
    , (case
        when lantes.cdleite is not null and ldepois.cdleite is null then lantes.dtleite
        when lantes.cdleite is null and ldepois.cdleite is not null then ldepois.dtleite
        when (ia.data - lantes.dtleite) < (ldepois.dtleite - ia.data) then lantes.dtleite
        when (ia.data - lantes.dtleite) > (ldepois.dtleite - ia.data) then ldepois.dtleite
        else null end) as data_leite
    , (case
        when lantes.cdleite is not null and ldepois.cdleite is null then lantes.pesototal
        when lantes.cdleite is null and ldepois.cdleite is not null then ldepois.pesototal
        when (ia.data - lantes.dtleite) < (ldepois.dtleite - ia.data) then lantes.pesototal
        when (ia.data - lantes.dtleite) > (ldepois.dtleite - ia.data) then ldepois.pesototal
        else null end) as peso_leite
from animal an
    join reproducao ia on ia.cdanimal = an.cdanimal and ia.cdtiporeproducao in (1,2,3)
    left join leite lantes on lantes.cdleite =
        (select first 1 re.cdleite
        from leite re
        where re.cdanimal = ia.cdanimal
            and re.dtleite between (ia.data - 15) and ia.data
        order by re.dtleite desc)
    left join leite ldepois on ldepois.cdleite =
        (select first 1 re.cdleite
        from leite re
        where re.cdanimal = ia.cdanimal
            and re.dtleite between (ia.data + 1) and (ia.data + 15)
        order by re.dtleite asc)
order by an.numordenado, ia.data